=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

.PHONY: override_dh_auto_configure   \
        override_dh_auto_build-indep \
        override_dh_auto_install     \
        override_dh_auto_test        \
        override_dh_strip

override_dh_auto_configure:
	dh_auto_configure --  \
	    -DCMAKE_INSTALL_PREFIX:PATH=/usr \
	    -DBUILD_EXAMPLES:BOOL=False \
	    -DMAKE_BUILD_TYPE:STRING=RelWithDebInfo

override_dh_auto_build-indep:
	dh_auto_build -- doxygen

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake 
	
	# Remove extra LICENSE and INSTALL file
	rm debian/tmp/usr/share/doc/simbody/LICENSE.txt
	rm debian/tmp/usr/share/doc/simbody/CHANGELOG.md

override_dh_strip:
	dh_strip -a --dbg-package=libsimbody3.5v5-dbg

%:
	dh $@ --parallel --buildsystem=cmake
